#define _LARGEFILE_SOURCE
#define _FILE_OFFSET_BITS 64
#define GTK_DISABLE_DEPRECATED 1

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include <unistd.h>

#include <sys/stat.h>
#include <sys/wait.h>

#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>

#include "include/macros.h"
#include "include/misc.h"
#include "include/callbacks.h"
#include "include/ui.h"

GtkWidget *mainwin;//main window
GtkStatusIcon* trayicon;//tray icon
GtkWidget *convert;//convert button
GtkWidget *stop;//stop button
GtkWidget *pause_continue;//pause and continue button
GtkWidget *output_path;//output path's entry
GtkWidget *list;//main list
GtkListStore *store;//list store
GtkWidget *a_bitrate_spin;
GtkWidget *a_bitrate_auto;
GtkWidget *a_codec_combo;//audio sampling rate
GtkWidget *a_sr_combo;//audio sampling rate
GtkWidget *a_channel_combo;//audio channels
GtkWidget *a_volume_spin;
GtkWidget *a_volume_auto;
GtkWidget *threads_combo;//number of threads
GtkWidget *progress_bar;//progress bar
GtkWidget *in_file_info;//file information

enum {
  COLUMN_NAME,
  COLUMN_STATUS,
  COLUMN_PATH,
  N_COLUMNS
};

struct stats {
float time;
unsigned int total_hours;
unsigned int total_minutes;
float total_seconds;
double total_time;
} stats;

struct states {
GPid pid;//process pid of encoder
gboolean paused;//paused or not paused transcoding
gboolean stoped;//stoped or not stoped transcoding
char last_input_folder[100];
char last_output_folder[100];
unsigned short notebook_tab;
char ffmpeg_path[25];
unsigned short windows_is_visible;
} states;

//--------------setting up codecs(start)----------------//
typedef struct acodec{
char* codec_name;
char* combo_name;
char* extension;
}acodec;

acodec  acodecs[C_NUM_A_CODECS];

void setup_settings(void)
{
	short counter = 0;
	
	acodecs[counter].codec_name="libvorbis";
	acodecs[counter].combo_name="Vorbis";
	acodecs[counter].extension=".ogg";
	counter++;
	
	acodecs[counter].codec_name="aac";
	acodecs[counter].combo_name="Aac";
	acodecs[counter].extension=".mp4";
	counter++;
	
	acodecs[counter].codec_name="libmp3lame";
	acodecs[counter].combo_name="Mp3";
	acodecs[counter].extension=".mp3";
	counter++;
	
	acodecs[counter].codec_name="mp2";
	acodecs[counter].combo_name="Mp2";
	acodecs[counter].extension=".mp2";
	counter++;
	
	acodecs[counter].codec_name="libopencore_amrnb";
	acodecs[counter].combo_name="AmrNB";
	acodecs[counter].extension=".amr";
	counter++;
	
	acodecs[counter].codec_name="flac";
	acodecs[counter].combo_name="Flac";
	acodecs[counter].extension=".flac";
	counter++;
	
}
void setup_states(void)
{
	states.pid=0;
	states.paused=0;
	states.stoped=1;
	states.notebook_tab=0;
	
	if( g_file_test("ffmpeg",G_FILE_TEST_IS_EXECUTABLE) )
	{
		strcpy( states.ffmpeg_path , "./ffmpeg" );
	}
	else if(g_file_test("/usr/bin/ffmpeg",G_FILE_TEST_IS_EXECUTABLE))
	{
		strcpy( states.ffmpeg_path , "/usr/bin/ffmpeg" );
	}
	else if(g_file_test("/usr/local/bin/ffmpeg",G_FILE_TEST_IS_EXECUTABLE))
	{
		strcpy( states.ffmpeg_path , "/usr/local/bin/ffmpeg" );
	}
	else
	{
		printf("\n could not find ffmpeg \n\n");
		exit(2);
	}
	
	states.windows_is_visible = 1;
}
//--------------setting up codecs(end)----------------//
int main (int argc, char **argv)
{
	setup_settings();
	
	setup_states();
	
	gtk_init (&argc, &argv);
	
	init_ui();
	
	load_config();
	
	gtk_widget_show_all(mainwin);
	
	gtk_main();
	
	return 0;
}

#include "include/misc.c"
#include "include/callbacks.c"
#include "include/ui.c"
